DEFDBL B-E
PRINT
PRINT "To convert the three-column data files *.cb3 produced by CB3FIL1 or"
PRINT "CB3FIL2 or CB3FILM.BAS for one target and one projectile, relativistically;"
PRINT "into Files *L.3I"
PRINT "to be plotted as Stopping Number versus(E/A)/I^(2/3), taking I from ICRU49,table 2.8"
PRINT
'Note: the relativistic calculation of beta is correct down to EoverA=1E-7,
'if the projectile mass A1 is entered in u!

'INPUT "Enter element symbol of projectile (e.g.,O) : "; Proj$
Proj$ = "O"

OPEN "Projs.lst" FOR INPUT AS #5            'Find Z1
DO WHILE NOT EOF(5)
        INPUT #5, Z1, ProjList$
        IF Proj$ = ProjList$ THEN EXIT DO
        IF Z1 = 93 THEN PRINT "No projectile name found": STOP
LOOP
CLOSE
                                    'To find Z2:
INPUT "Enter element symbol of target (e.g., C, N2, etc.) : "; Targ$
OPEN "Targets.lst" FOR INPUT AS #5
DO WHILE NOT EOF(5)
        INPUT #5, Z2, TargList$
        IF Targ$ = TargList$ THEN EXIT DO
        IF Z2 = 140 THEN PRINT "No target name found": STOP
LOOP
CLOSE

OPEN "atdata.txt" FOR INPUT AS #5        'Find A2
LINE INPUT #5, Heading$
LINE INPUT #5, Heading$
DO WHILE NOT EOF(5)
        INPUT #5, Z, C1, C2, A2, C3, C4  'Find rel. at. mass of natural element
        IF Z = Z2 THEN EXIT DO
LOOP
CLOSE

OPEN "Ivalues1.I49" FOR INPUT AS #5          'Find I2
DO WHILE NOT EOF(5)
        INPUT #5, Z, I2
        IF Z = Z2 THEN EXIT DO

LOOP
CLOSE

FileName$ = Proj$ + Targ$
InFile$ = FileName$ + ".cb3"
OutFile$ = FileName$ + "L.3I"
OPEN InFile$ FOR INPUT AS #1
OPEN OutFile$ FOR OUTPUT AS #2

PRINT "     E           "; Proj$ + Targ$
PRINT #2, "     E           "; Proj$ + Targ$
DO WHILE NOT EOF(1)
        INPUT #1, EoverA, S, A1              'E/A in MeV,S in MeV/(mg/cm2)
        OPEN "Masses.lst" FOR INPUT AS #6    'Rest Energies of Projectiles in MeV
        INPUT #6, Heading$
        DO
                INPUT #6, Z1L, A1L, E0         'To find E0
                IF Z1L = 99 THEN PRINT "No Mass found": STOP
                IF Z1L <> Z1 THEN GOTO there:
                IF A1L <> A1 THEN GOTO there:  ELSE EXIT DO
there:  LOOP
        CLOSE #6
        E = E0 + EoverA * A1                'Double Precision!
        beta = SQR(1 - (E0 / E) ^ 2)        'relativistic
        L = S * beta ^ 2 / (.000307075# * Z1 ^ 2 * Z2 / A2)  '.307075 MeVcm2/g, see Berger
        PRINT USING "###.#######  "; EoverA; EoverA / I2 ^ (2 / 3); L
        PRINT #2, USING "###.#######  "; EoverA / I2 ^ (2 / 3); L
LOOP
END

